import datetime
import time
from datetime import datetime

import schedule
from loguru import logger

from common import Feishu
from common.sql_help import sqlCollect



def bot_bygj_data():
    all_count = sqlCollect.get_bygj_all_count()
    fj = sqlCollect.get_bygj_count("范军")
    # ytd_lt = sqlCollect.get_ytd_bygj_count("范军")

    lt = sqlCollect.get_bygj_count("鲁涛")
    # ytd_lt = sqlCollect.get_ytd_bygj_count("鲁涛")

    yht = sqlCollect.get_bygj_count("余海涛")
    # ytd_yht = sqlCollect.get_ytd_bygj_count("余海涛")

    lq = sqlCollect.get_bygj_count("罗情")
    # ytd_lq = sqlCollect.get_ytd_bygj_count("罗情")

    lsy = sqlCollect.get_bygj_count("刘诗雨")
    # ytd_lsy = sqlCollect.get_ytd_bygj_count("刘诗雨")

    zf = sqlCollect.get_bygj_count("张峰")
    # ytd_zf = sqlCollect.get_ytd_bygj_count("张峰")

    zxq = sqlCollect.get_bygj_count("周仙琴")
    # ytd_zxq = sqlCollect.get_ytd_bygj_count("周仙琴")

    wxk = sqlCollect.get_bygj_count("王雪珂")


    xx = sqlCollect.get_bygj_count("信欣")

    text = (
        f"**总条数: **{int(all_count[0][0])}**条**\n"
        f"**范军: **{int(fj[0][0])}**条**\n"
        f"**鲁涛: **{int(lt[0][0])}**条**\n"
        f"**余海涛: **{int(yht[0][0])}**条**\n"
        f"**罗情: **{int(lq[0][0])}**条**\n"
        f"**刘诗雨: **{int(lsy[0][0])}**条**\n"
        f"**张峰: **{int(zf[0][0])}**条**\n"
        f"**周仙琴: **{int(zxq[0][0])}**条**\n"
        f"**王雪珂: **{int(wxk[0][0])}**条**\n"
        f"**信欣: **{int(xx[0][0])}**条**\n"

    )
    Feishu.finish_bot(text,
                      "https://open.feishu.cn/open-apis/bot/v2/hook/1f3aa0e0-f872-4541-8fc7-6dcc825920ea",
                      f"【 搬运工具{datetime.now().strftime('%Y年%m月%d日 %H时')}之前的数据 】")


"""爬虫"""
def bot_crawler_data():
    try:
        xng_author = sqlCollect.get_crawler_count("xiaoniangao")
        xng_author_ytd = sqlCollect.get_ytd_crawler_count("xiaoniangao")

        xng_tjl = sqlCollect.get_crawler_count("xiaoniangaotuijianliu")
        xng_tjl_ytd = sqlCollect.get_ytd_crawler_count("xiaoniangaotuijianliu")

        zfqz_tjl = sqlCollect.get_crawler_count("zhufuquanzituijianliu")
        zfqz_tjl_ytd = sqlCollect.get_ytd_crawler_count("zhufuquanzituijianliu")

        bszf = sqlCollect.get_crawler_count("benshanzhufu")
        bszf_ytd = sqlCollect.get_ytd_crawler_count("benshanzhufu")

        fqw = sqlCollect.get_crawler_count("fuqiwang")
        fqw_ytd = sqlCollect.get_ytd_crawler_count("fuqiwang")

        jdfqw = sqlCollect.get_crawler_count("jingdianfuqiwang")
        jdfqw_ytd = sqlCollect.get_ytd_crawler_count("jingdianfuqiwang")

        ttjfq = sqlCollect.get_crawler_count("tiantianjufuqi")
        ttjfq_ytd = sqlCollect.get_ytd_crawler_count("tiantianjufuqi")

        zfnnsxjx = sqlCollect.get_crawler_count("zhufuniannianshunxinjixiang")
        zfnnsxjx_ytd = sqlCollect.get_ytd_crawler_count("zhufuniannianshunxinjixiang")

        text = (
            f"**小年糕: 当日**{int(xng_author[0][0])}**条/昨日**{int(xng_author_ytd[0][0])}**条**\n"
            f"**小年糕推荐流: 当日**{int(xng_tjl[0][0])}**条/昨日**{int(xng_tjl_ytd[0][0])}**条**\n"
            f"**祝福圈子推荐流: 当日**{int(zfqz_tjl[0][0])}**条/昨日**{int(zfqz_tjl_ytd[0][0])}**条**\n"
            f"**本山祝福: 当日**{int(bszf[0][0])}**条/昨日**{int(bszf_ytd[0][0])}**条**\n"
            f"**福气旺: 当日**{int(fqw[0][0])}**条/昨日**{int(fqw_ytd[0][0])}**条**\n"
            f"**经典福气旺: 当日**{int(jdfqw[0][0])}**条/昨日**{int(jdfqw_ytd[0][0])}**条**\n"
            f"**天天聚福气: 当日**{int(ttjfq[0][0])}**条/昨日**{int(ttjfq_ytd[0][0])}**条**\n"
            f"**喜鹊播-祝福年年顺心吉祥: 当日**{int(zfnnsxjx[0][0])}**条/昨日**{int(zfnnsxjx_ytd[0][0])}**条**\n"

        )
        Feishu.finish_bot(text,
                          "https://open.feishu.cn/open-apis/bot/v2/hook/805ab4fe-0246-409c-b383-ea25831148e6",
                          f"【 爬虫{datetime.now().strftime('%Y年%m月%d日 %H时')}与昨天当前小时之前的数据 】")

    except Exception as e:
        logger.error(f"[+] 报警失败{e}")


"""机器自制"""
def bot_carry_data():
    try:
        sph_feed_count = sqlCollect.get_channel_count("视频号推荐流", "视频号推荐流")
        ytd_sph_feed_count = sqlCollect.get_ytd_channel_count("视频号推荐流", "视频号推荐流")

        ks_feed_count = sqlCollect.get_channel_count("快手推荐流", "快手推荐流")
        ytd_ks_feed_count = sqlCollect.get_ytd_channel_count("快手推荐流", "快手推荐流")

        ks_xcx_count = sqlCollect.get_channel_count("快手小程序", "快手小程序")
        ytd_ks_xcx_count = sqlCollect.get_ytd_channel_count("快手小程序", "快手小程序")

        ks_sou_count = sqlCollect.get_channel_count("快手搜索", "品类关键词搜索")
        ytd_ks_sou_count = sqlCollect.get_ytd_channel_count("快手搜索", "品类关键词搜索")

        dy_sou_count = sqlCollect.get_channel_count("抖音搜索", "品类关键词搜索")
        ytd_dy_sou_count = sqlCollect.get_ytd_channel_count("抖音搜索", "品类关键词搜索")

        sph_sou_count = sqlCollect.get_channel_count("视频号搜索", "品类关键词搜索")
        ytd_sph_sou_count = sqlCollect.get_ytd_channel_count("视频号搜索", "品类关键词搜索")

        dy_count = sqlCollect.get_name_count("抖音品类账号")
        ytd_dy_count = sqlCollect.get_ytd_name_count("抖音品类账号")

        ks_count = sqlCollect.get_name_count("快手品类账号")
        ytd_ks_count = sqlCollect.get_ytd_name_count("快手品类账号")

        sph_count = sqlCollect.get_name_count("视频号品类账号")
        ytd_sph_count = sqlCollect.get_ytd_name_count("视频号品类账号")

        xx_count = sqlCollect.get_name_count("信欣")
        ytd_xx_count = sqlCollect.get_ytd_name_count("信欣")

        dd_count = sqlCollect.get_name_count("单点视频")
        ytd_dd_count = sqlCollect.get_ytd_name_count("单点视频")

        text = (
            f"**抖音品类账号: 今日**{int(dy_count[0][0])}**条/昨日**{int(ytd_dy_count[0][0])}**条/每日目标量:470条**\n"
            f"**抖音搜索: 今日**{int(dy_sou_count[0][0])}**条/昨日**{int(ytd_dy_sou_count[0][0])}**条/每日目标量:860条**\n"
            f"**视频号品类账号: 今日**{int(sph_count[0][0])}**条/昨日**{int(ytd_sph_count[0][0])}**条/每日目标量:80条**\n"
            f"**视频号推荐流: 今日**{int(sph_feed_count[0][0])}**条/昨日**{int(ytd_sph_feed_count[0][0])}**条/每日目标量:110条**\n"
            f"**视频号搜索: 今日**{int(sph_sou_count[0][0])}**条/昨日**{int(ytd_sph_sou_count[0][0])}**条/每日目标量:100条**\n"
            f"**快手品类账号: 今日**{int(ks_count[0][0])}**条/昨日**{int(ytd_ks_count[0][0])}**条/每日目标量:560条**\n"
            f"**快手推荐流: 今日**{int(ks_feed_count[0][0])}**条/昨日**{int(ytd_ks_feed_count[0][0])}**条/每日目标量:130条**\n"
            f"**快手小程序: 今日**{int(ks_xcx_count[0][0])}**条/昨日**{int(ytd_ks_xcx_count[0][0])}**条/每日目标量:?条**\n"
            f"**快手搜索: 今日**{int(ks_sou_count[0][0])}**条/昨日**{int(ytd_ks_sou_count[0][0])}**条/每日目标量:590条**\n"
            f"**相似溯源（xx）: 今日**{int(xx_count[0][0])}**条/昨日**{int(ytd_xx_count[0][0])}**条/每日目标量:0条**\n"
            f"**单点视频: 今日**{int(dd_count[0][0])}**条/昨日**{int(ytd_dd_count[0][0])}**条**\n"
        )

        Feishu.finish_bot(text,
                          "https://open.feishu.cn/open-apis/bot/v2/hook/805ab4fe-0246-409c-b383-ea25831148e6",
                          f"【 自制视频{datetime.now().strftime('%Y年%m月%d日 %H时')}与昨天当前小时之前的数据 】")



    except Exception as e:
        logger.error(f"[+] 报警失败{e}")




def schedule_tasks():
    schedule.every().hour.at(":05").do(bot_carry_data)
    schedule.every().hour.at(":10").do(bot_crawler_data)
    schedule.every().hour.at(":08").do(bot_bygj_data)


if __name__ == "__main__":
    # bot_bygj_data()
    # bot_crawler_data()
    schedule_tasks()  # 调用任务调度函数
    while True:
        schedule.run_pending()
        time.sleep(1)  # 每秒钟检查一次
    # bot_carry_data()

